VERSION 5.00
Begin VB.Form frmLittleDrawTest 
   Caption         =   "LittleDrawTest"
   ClientHeight    =   1080
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5130
   LinkTopic       =   "Form1"
   ScaleHeight     =   1080
   ScaleWidth      =   5130
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtFileName 
      Height          =   285
      Left            =   480
      TabIndex        =   2
      Top             =   120
      Width           =   4575
   End
   Begin VB.CommandButton cmdGenerate 
      Caption         =   "Generate File"
      Height          =   375
      Left            =   1920
      TabIndex        =   0
      Top             =   600
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "File"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   375
   End
End
Attribute VB_Name = "frmLittleDrawTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Function X(ByVal t As Double) As Double
    X = 2000 + 2000 * (27 * Cos(t) + 15 * Cos(t * 20 / 7)) / 42
End Function
Private Function Y(ByVal t As Double) As Double
    Y = 2000 + 2000 * (27 * Sin(t) + 15 * Sin(t * 20 / 7)) / 42
End Function


Private Sub cmdGenerate_Click()
Const PI = 3.14159265
Const DT = PI / 40

Dim ld_picture As LittleDrawServer.ld_picture
Dim t As Double
Dim X1 As Single
Dim Y1 As Single
Dim X2 As Single
Dim Y2 As Single
Dim file_name As String
Dim file_title As String
Dim pos As Long

    ' Make a new LittleDraw picture.
    Set ld_picture = New LittleDrawServer.ld_picture

    ' Generate line segments for the picture.
    t = 0
    X2 = X(t)
    Y2 = Y(t)
    Do While t < 14 * PI
        t = t + DT
        X1 = X2
        Y1 = Y2
        X2 = X(t)
        Y2 = Y(t)
        ld_picture.NewLine X1, Y1, X2, Y2
    Loop

    ' Generate the final segment.
    X1 = X2
    Y1 = Y2
    t = 14 * PI
    X2 = X(t)
    Y2 = Y(t)
    ld_picture.NewLine X1, Y1, X2, Y2

    ' Save the picture.
    file_name = txtFileName.Text
    pos = InStrRev(file_name, "\")
    file_title = Mid$(file_name, pos + 1)
    ld_picture.DataSave file_name, file_title
    MsgBox "Ok"
End Sub
Private Sub Form_Load()
Dim file_name As String

    file_name = App.Path
    If Right$(file_name, 1) <> "\" Then file_name = file_name & "\"
    txtFileName.Text = file_name & "Cycloid.ldf"
End Sub

Private Sub Form_Resize()
Dim wid As Single

    wid = ScaleWidth - txtFileName.Left
    If wid < 120 Then wid = 120
    txtFileName.Width = wid

    cmdGenerate.Left = (ScaleWidth - cmdGenerate.Width) / 2
End Sub


